#include <cassert>
#include <cmath>

#include "Fibonacci.h"

long Fibonacci::_F = 0L;

const double Fibonacci::golden_number = (1. + ::sqrt(5.)) / 2.;

Fibonacci::Fibonacci(long n) : result(recursive(n)) {
    cost = _F;
    _F = 0L;
}

long Fibonacci::recursive(long n) const {
    assert(n >= 0L);
    if (n == 0L) return 0L;
    if (n == 1L) return 1L;
    _F++;
    return recursive(n - 1L) + recursive(n - 2L);
}

long Fibonacci::iterative(long n) const {
    assert(n >= 0L);
    if (n == 0L) return 0L;
    if (n == 1L) return 1L;
    long u = 1L, v = 0L, u0, v0;
    for (long i = 2L; i <= n; i++) {
        u0 = u;
        v0 = v;
        u = u0 + v0;
        v = u0;
    }
    return u;
}

long Fibonacci::binet(long n) const {
    assert(n >= 0L);
    return long((::pow(golden_number, double(n))-::pow((1. - golden_number), double(n))) / ::sqrt(5.));
}